﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AuKCSharp
{
    public class Rucksack
    {
        private Dictionary<int, Gegenstand> gegenstaende = new Dictionary<int, Gegenstand>();
        //private HashMap<Integer, HashMap<Integer, Integer>> memoliste;
        private Dictionary<int, Dictionary<int, int>> memoliste = new Dictionary<int, Dictionary<int, int>>();
        private int rekursiveAufrufe;
        public Rucksack()
        {
            gegenstaende.Add(1, new Gegenstand(13, 19));
            gegenstaende.Add(2, new Gegenstand(11, 20));
            gegenstaende.Add(3, new Gegenstand(17, 23));
            gegenstaende.Add(4, new Gegenstand(15, 21));
            gegenstaende.Add(5, new Gegenstand(16, 27));
            gegenstaende.Add(6, new Gegenstand(14, 25));
            gegenstaende.Add(7, new Gegenstand(18, 25));
            gegenstaende.Add(8, new Gegenstand(10, 18));
            gegenstaende.Add(9, new Gegenstand(19, 24));
            gegenstaende.Add(10, new Gegenstand(12, 17));

        }
        public int[] iterativ(int kapazitaet)
        {
            int[] zeileAlt = new int[kapazitaet + 1];
            int[] zeileNeu = new int[kapazitaet + 1];
            String[] zeileAltG = new String[kapazitaet + 1];
            String[] zeileNeuG = new String[kapazitaet + 1];
            for (int z = 1; z <= gegenstaende.Count; z++)
            {
                zeileNeu.CopyTo(zeileAlt, 0);
                zeileNeuG.CopyTo(zeileAltG, 0);
                Gegenstand aktueller = gegenstaende[z];

                int gewicht = aktueller.Gewicht;
                for (int s = 0; s <= kapazitaet; s++)
                {
                    if (s >= gewicht)
                    {
                        int temp = zeileAlt[s - gewicht] + aktueller.Wert;
                        if (temp > zeileAlt[s])
                        {
                            zeileNeu[s] = temp;
                            if (zeileAltG[s - gewicht] == null)
                            {
                                zeileNeuG[s] = z + "";
                            }
                            else
                            {

                                zeileNeuG[s] = zeileAltG[s - gewicht] + ";" + z;
                            }
                        }
                    }
                }
            }
            if (zeileNeuG[kapazitaet] != null)
            {
                String[] g = zeileNeuG[kapazitaet].Split(';');
                int[] back = new int[g.Length];
                for (int i = 0; i < g.Length; i++)
                {
                    back[i] = Convert.ToInt32(g[i]);
                }
                return back;
            }
            else
            {
                return null;
            }

        }
        public void printIterativ(int k)
        {
            int[] inRucksack = iterativ(k);
            int gesamt = 0;
            int wert = 0;
            for (int i = 0; i < inRucksack.Length; i++)
            {
                int z = inRucksack[i];
                int g = (int)gegenstaende[z].Gewicht;
                int w = (int)gegenstaende[z].Wert;
                gesamt += g;
                wert += w;
                System.Console.WriteLine("Gegenstand " + z + " ist im Rucksack");
            }
            System.Console.WriteLine("--------------------------");
            System.Console.WriteLine("Wert im Rucksack: " + wert);
            System.Console.WriteLine("Gesamtgewicht: " + gesamt + " von " + k);
        }

        public int gesamtwertRekursiv(int kapazitaet)
        {
            rekursiveAufrufe = 0;
            return gesamtWert(gegenstaende.Count, kapazitaet);
        }
        public int gesamtwertRekursivMemo(int kapazitaet)
        {
            rekursiveAufrufe = 0;
            return gesamtWert1(gegenstaende.Count, kapazitaet);
        }
        //Stelle für rekursiven Aufruf?
        private int gesamtWert(int pos, int kapazitaet)
        {
            rekursiveAufrufe++;
            if (pos == 0)
            {
                return 0;
            }
            else
            {
                if (gegenstaende[pos].Wert > kapazitaet)
                {
                    return gesamtWert(pos - 1, kapazitaet);
                }
                else
                {
                    int var1 = gesamtWert(pos - 1, kapazitaet);
                    int var2 = gesamtWert(pos - 1, kapazitaet - (int)gegenstaende[pos].Gewicht) + (int)gegenstaende[pos].Wert;
                    if (var1 > var2)
                    {

                        return var1;
                    }
                    else
                    {
                        return var2;
                    }
                    //entweder aktueller Wert + letzten Wert, oder ohne diesen
                }
            }
        }
        private int gesamtWert1(int pos, int kapazitaet)
        {
            rekursiveAufrufe++;
            if (pos == 0)
            {
                return 0;
            }
            else
            {
                if (gegenstaende[pos].Gewicht > kapazitaet)
                {
                    return gesamtWertMemo(pos - 1, kapazitaet);
                }
                else
                {
                    int var1 = gesamtWertMemo(pos - 1, kapazitaet);
                    int var2 = gesamtWertMemo(pos - 1, kapazitaet - (int)gegenstaende[pos].Gewicht) + (int)gegenstaende[pos].Wert;
                    if (var1 > var2)
                    {
                        return var1;
                    }
                    else
                    {
                        return var2;
                    }
                }
            }
        }
        private int gesamtWertMemo(int pos, int kapazitaet)
        {
            if (memoliste.ContainsKey(pos))
            {
                if (memoliste[pos].ContainsKey(kapazitaet))
                {
                    return memoliste[pos][kapazitaet];
                }
                else
                {
                    int resultat = gesamtWert1(pos, kapazitaet);
                    memoliste[pos].Add(kapazitaet, resultat);
                    return resultat;
                }
            }
            else
            {
                int resultat = gesamtWert1(pos, kapazitaet);
                Dictionary<int, int> temp = new Dictionary<int, int>();
                temp.Add(kapazitaet, resultat);
                memoliste.Add(pos, temp);
                return resultat;
            }
        }
    }

    public class Gegenstand
    {
        private int _Gewicht;
        private int _Wert;
        private double _GW;

        public Gegenstand(int g, int w)
        {
            _Gewicht = g;
            _Wert = w;
            _GW = ((double)g) / ((double)w);
        }

        public int Gewicht
        {
            get { return _Gewicht; }
            // set { _Gewicht = value; }
        }
        public int Wert
        {
            get { return _Wert; }
            //  set { _Wert = value; }
        }
        public double GW
        {
            get { return _GW; }
            //  set { _GW = value; }
        }
    }
}
